## ╭──────────────────────────────────────────────────────────────────────────╮
## │                                                                          │
## │             Distributed under the CC0 public domain license.             │
## │   By Marrub / Alison.  Attribution is encouraged, though not required.   │
## │                See licenses/cc0.txt for more information.                │
## │                                                                          │
## ├──────────────────────────────────────────────────────────────────────────┤
## │                                                                          │
## │ Utility libraries for tools.                                             │
## │                                                                          │
## ╰──────────────────────────────────────────────────────────────────────────╯

require_relative "corinth/io.rb"
require_relative "corinth/token.rb"
require_relative "corinth/tokenstream.rb"
require_relative "corinth/parsestate.rb"

def common_main
   begin
      yield
   rescue => exc
      puts "Error:\n#{exc.backtrace.join "\n"}\n#{exc.message}"
      exit false
   end
end

def generated_header progname
   <<_end_
// ╭──────────────────────────────────────────────────────────────────────────╮
// │                                                                          │
// │                     This file cannot be copyrighted.                     │
// │                                                                          │
// ├──────────────────────────────────────────────────────────────────────────┤
// │                                                                          │
// │#{" This file was generated by #{progname}.".ljust 74}│
// │ Edit only if you aren't going to recompile.                              │
// │                                                                          │
// ╰──────────────────────────────────────────────────────────────────────────╯
_end_
end

## EOF
